Index: /trunk/src/sys/arch/mips/rmi/rmixl_intr.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_intr.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_intr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_intr.c,v 1.1.2.19 2010/05/06 20:48:39 cliff Exp $	*/
+/*	$NetBSD: rmixl_intr.c,v 1.1.2.30 2011/04/29 08:26:32 matt Exp $	*/
 
 /*-
@@ -65,7 +65,8 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_intr.c,v 1.1.2.19 2010/05/06 20:48:39 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_intr.c,v 1.1.2.30 2011/04/29 08:26:32 matt Exp $");
 
 #include "opt_ddb.h"
+#include "opt_multiprocessor.h"
 #define	__INTR_PRIVATE
 
@@ -77,4 +78,5 @@
 #include <sys/kernel.h>
 #include <sys/atomic.h>
+#include <sys/mutex.h>
 #include <sys/cpu.h>
 
@@ -83,4 +85,5 @@
 
 #include <mips/cpu.h>
+#include <mips/cpuset.h>
 #include <mips/locore.h>
 
@@ -94,5 +97,5 @@
 #include <dev/pci/pcivar.h>
 
-// #define IOINTR_DEBUG	1
+//#define IOINTR_DEBUG 1
 #ifdef IOINTR_DEBUG
 int iointr_debug = IOINTR_DEBUG;
@@ -117,5 +120,5 @@
  * IRT assignments depends on the RMI chip family
  * (XLS1xx vs. XLS2xx vs. XLS3xx vs. XLS6xx)
- * use the right irq (and display string table) for the CPU that's running.
+ * use the right display string table for the CPU that's running.
  */
 
@@ -125,36 +128,36 @@
  */
 static const char * const rmixl_irtnames_xlrxxx[NIRTS] = {
-	"int 0 (watchdog)",	/*  0 */
-	"int 1 (timer0)",	/*  1 */
-	"int 2 (timer1)",	/*  2 */
-	"int 3 (timer2)",	/*  3 */
-	"int 4 (timer3)",	/*  4 */
-	"int 5 (timer4)",	/*  5 */
-	"int 6 (timer5)",	/*  6 */
-	"int 7 (timer6)",	/*  7 */
-	"int 8 (timer7)",	/*  8 */
-	"int 9 (uart0)",	/*  9 */
-	"int 10 (uart1)",	/* 10 */
-	"int 11 (i2c0)",	/* 11 */
-	"int 12 (i2c1)",	/* 12 */
-	"int 13 (pcmcia)",	/* 13 */
-	"int 14 (gpio)",	/* 14 */
-	"int 15 (hyper)",	/* 15 */
-	"int 16 (pcix)",	/* 16 */
-	"int 17 (gmac0)",	/* 17 */
-	"int 18 (gmac1)",	/* 18 */
-	"int 19 (gmac2)",	/* 19 */
-	"int 20 (gmac3)",	/* 20 */
-	"int 21 (xgs0)",	/* 21 */
-	"int 22 (xgs1)",	/* 22 */
-	"int 23 (irq23)",	/* 23 */
-	"int 24 (hyper_fatal)",	/* 24 */
-	"int 25 (bridge_aerr)",	/* 25 */
-	"int 26 (bridge_berr)",	/* 26 */
-	"int 27 (bridge_tb)",	/* 27 */
-	"int 28 (bridge_nmi)",	/* 28 */
-	"int 29 (bridge_sram_derr)",	/* 29 */
-	"int 30 (gpio_fatal)",	/* 30 */
-	"int 31 (reserved)",	/* 31 */
+	"pic int 0 (watchdog)",		/*  0 */
+	"pic int 1 (timer0)",		/*  1 */
+	"pic int 2 (timer1)",		/*  2 */
+	"pic int 3 (timer2)",		/*  3 */
+	"pic int 4 (timer3)",		/*  4 */
+	"pic int 5 (timer4)",		/*  5 */
+	"pic int 6 (timer5)",		/*  6 */
+	"pic int 7 (timer6)",		/*  7 */
+	"pic int 8 (timer7)",		/*  8 */
+	"pic int 9 (uart0)",		/*  9 */
+	"pic int 10 (uart1)",		/* 10 */
+	"pic int 11 (i2c0)",		/* 11 */
+	"pic int 12 (i2c1)",		/* 12 */
+	"pic int 13 (pcmcia)",		/* 13 */
+	"pic int 14 (gpio)",		/* 14 */
+	"pic int 15 (hyper)",		/* 15 */
+	"pic int 16 (pcix)",		/* 16 */
+	"pic int 17 (gmac0)",		/* 17 */
+	"pic int 18 (gmac1)",		/* 18 */
+	"pic int 19 (gmac2)",		/* 19 */
+	"pic int 20 (gmac3)",		/* 20 */
+	"pic int 21 (xgs0)",		/* 21 */
+	"pic int 22 (xgs1)",		/* 22 */
+	"pic int 23 (irq23)",		/* 23 */
+	"pic int 24 (hyper_fatal)",	/* 24 */
+	"pic int 25 (bridge_aerr)",	/* 25 */
+	"pic int 26 (bridge_berr)",	/* 26 */
+	"pic int 27 (bridge_tb)",	/* 27 */
+	"pic int 28 (bridge_nmi)",	/* 28 */
+	"pic int 29 (bridge_sram_derr)",/* 29 */
+	"pic int 30 (gpio_fatal)",	/* 30 */
+	"pic int 31 (reserved)",	/* 31 */
 };
 
@@ -164,36 +167,36 @@
  */
 static const char * const rmixl_irtnames_xls2xx[NIRTS] = {
-	"int 0 (watchdog)",	/*  0 */
-	"int 1 (timer0)",	/*  1 */
-	"int 2 (timer1)",	/*  2 */
-	"int 3 (timer2)",	/*  3 */
-	"int 4 (timer3)",	/*  4 */
-	"int 5 (timer4)",	/*  5 */
-	"int 6 (timer5)",	/*  6 */
-	"int 7 (timer6)",	/*  7 */
-	"int 8 (timer7)",	/*  8 */
-	"int 9 (uart0)",	/*  9 */
-	"int 10 (uart1)",	/* 10 */
-	"int 11 (i2c0)",	/* 11 */
-	"int 12 (i2c1)",	/* 12 */
-	"int 13 (pcmcia)",	/* 13 */
-	"int 14 (gpio_a)",	/* 14 */
-	"int 15 (irq15)",	/* 15 */
-	"int 16 (bridge_tb)",	/* 16 */
-	"int 17 (gmac0)",	/* 17 */
-	"int 18 (gmac1)",	/* 18 */
-	"int 19 (gmac2)",	/* 19 */
-	"int 20 (gmac3)",	/* 20 */
-	"int 21 (irq21)",	/* 21 */
-	"int 22 (irq22)",	/* 22 */
-	"int 23 (pcie_link2)",	/* 23 */
-	"int 24 (pcie_link3)",	/* 24 */
-	"int 25 (bridge_err)",	/* 25 */
-	"int 26 (pcie_link0)",	/* 26 */
-	"int 27 (pcie_link1)",	/* 27 */
-	"int 28 (irq28)",	/* 28 */
-	"int 29 (pcie_err)",	/* 29 */
-	"int 30 (gpio_b)",	/* 30 */
-	"int 31 (usb)",		/* 31 */
+	"pic int 0 (watchdog)",		/*  0 */
+	"pic int 1 (timer0)",		/*  1 */
+	"pic int 2 (timer1)",		/*  2 */
+	"pic int 3 (timer2)",		/*  3 */
+	"pic int 4 (timer3)",		/*  4 */
+	"pic int 5 (timer4)",		/*  5 */
+	"pic int 6 (timer5)",		/*  6 */
+	"pic int 7 (timer6)",		/*  7 */
+	"pic int 8 (timer7)",		/*  8 */
+	"pic int 9 (uart0)",		/*  9 */
+	"pic int 10 (uart1)",		/* 10 */
+	"pic int 11 (i2c0)",		/* 11 */
+	"pic int 12 (i2c1)",		/* 12 */
+	"pic int 13 (pcmcia)",		/* 13 */
+	"pic int 14 (gpio_a)",		/* 14 */
+	"pic int 15 (irq15)",		/* 15 */
+	"pic int 16 (bridge_tb)",	/* 16 */
+	"pic int 17 (gmac0)",		/* 17 */
+	"pic int 18 (gmac1)",		/* 18 */
+	"pic int 19 (gmac2)",		/* 19 */
+	"pic int 20 (gmac3)",		/* 20 */
+	"pic int 21 (irq21)",		/* 21 */
+	"pic int 22 (irq22)",		/* 22 */
+	"pic int 23 (pcie_link2)",	/* 23 */
+	"pic int 24 (pcie_link3)",	/* 24 */
+	"pic int 25 (bridge_err)",	/* 25 */
+	"pic int 26 (pcie_link0)",	/* 26 */
+	"pic int 27 (pcie_link1)",	/* 27 */
+	"pic int 28 (irq28)",		/* 28 */
+	"pic int 29 (pcie_err)",	/* 29 */
+	"pic int 30 (gpio_b)",		/* 30 */
+	"pic int 31 (usb)",		/* 31 */
 };
 
@@ -203,36 +206,36 @@
  */
 static const char * const rmixl_irtnames_xls1xx[NIRTS] = {
-	"int 0 (watchdog)",	/*  0 */
-	"int 1 (timer0)",	/*  1 */
-	"int 2 (timer1)",	/*  2 */
-	"int 3 (timer2)",	/*  3 */
-	"int 4 (timer3)",	/*  4 */
-	"int 5 (timer4)",	/*  5 */
-	"int 6 (timer5)",	/*  6 */
-	"int 7 (timer6)",	/*  7 */
-	"int 8 (timer7)",	/*  8 */
-	"int 9 (uart0)",	/*  9 */
-	"int 10 (uart1)",	/* 10 */
-	"int 11 (i2c0)",	/* 11 */
-	"int 12 (i2c1)",	/* 12 */
-	"int 13 (pcmcia)",	/* 13 */
-	"int 14 (gpio_a)",	/* 14 */
-	"int 15 (irq15)",	/* 15 */
-	"int 16 (bridge_tb)",	/* 16 */
-	"int 17 (gmac0)",	/* 17 */
-	"int 18 (gmac1)",	/* 18 */
-	"int 19 (gmac2)",	/* 19 */
-	"int 20 (gmac3)",	/* 20 */
-	"int 21 (irq21)",	/* 21 */
-	"int 22 (irq22)",	/* 22 */
-	"int 23 (irq23)",	/* 23 */
-	"int 24 (irq24)",	/* 24 */
-	"int 25 (bridge_err)",	/* 25 */
-	"int 26 (pcie_link0)",	/* 26 */
-	"int 27 (pcie_link1)",	/* 27 */
-	"int 28 (irq28)",	/* 28 */
-	"int 29 (pcie_err)",	/* 29 */
-	"int 30 (gpio_b)",	/* 30 */
-	"int 31 (usb)",		/* 31 */
+	"pic int 0 (watchdog)",		/*  0 */
+	"pic int 1 (timer0)",		/*  1 */
+	"pic int 2 (timer1)",		/*  2 */
+	"pic int 3 (timer2)",		/*  3 */
+	"pic int 4 (timer3)",		/*  4 */
+	"pic int 5 (timer4)",		/*  5 */
+	"pic int 6 (timer5)",		/*  6 */
+	"pic int 7 (timer6)",		/*  7 */
+	"pic int 8 (timer7)",		/*  8 */
+	"pic int 9 (uart0)",		/*  9 */
+	"pic int 10 (uart1)",		/* 10 */
+	"pic int 11 (i2c0)",		/* 11 */
+	"pic int 12 (i2c1)",		/* 12 */
+	"pic int 13 (pcmcia)",		/* 13 */
+	"pic int 14 (gpio_a)",		/* 14 */
+	"pic int 15 (irq15)",		/* 15 */
+	"pic int 16 (bridge_tb)",	/* 16 */
+	"pic int 17 (gmac0)",		/* 17 */
+	"pic int 18 (gmac1)",		/* 18 */
+	"pic int 19 (gmac2)",		/* 19 */
+	"pic int 20 (gmac3)",		/* 20 */
+	"pic int 21 (irq21)",		/* 21 */
+	"pic int 22 (irq22)",		/* 22 */
+	"pic int 23 (irq23)",		/* 23 */
+	"pic int 24 (irq24)",		/* 24 */
+	"pic int 25 (bridge_err)",	/* 25 */
+	"pic int 26 (pcie_link0)",	/* 26 */
+	"pic int 27 (pcie_link1)",	/* 27 */
+	"pic int 28 (irq28)",		/* 28 */
+	"pic int 29 (pcie_err)",	/* 29 */
+	"pic int 30 (gpio_b)",		/* 30 */
+	"pic int 31 (usb)",		/* 31 */
 };
 
@@ -242,36 +245,36 @@
  */
 static const char * const rmixl_irtnames_xls4xx[NIRTS] = {
-	"int 0 (watchdog)",	/*  0 */
-	"int 1 (timer0)",	/*  1 */
-	"int 2 (timer1)",	/*  2 */
-	"int 3 (timer2)",	/*  3 */
-	"int 4 (timer3)",	/*  4 */
-	"int 5 (timer4)",	/*  5 */
-	"int 6 (timer5)",	/*  6 */
-	"int 7 (timer6)",	/*  7 */
-	"int 8 (timer7)",	/*  8 */
-	"int 9 (uart0)",	/*  9 */
-	"int 10 (uart1)",	/* 10 */
-	"int 11 (i2c0)",	/* 11 */
-	"int 12 (i2c1)",	/* 12 */
-	"int 13 (pcmcia)",	/* 13 */
-	"int 14 (gpio_a)",	/* 14 */
-	"int 15 (irq15)",	/* 15 */
-	"int 16 (bridge_tb)",	/* 16 */
-	"int 17 (gmac0)",	/* 17 */
-	"int 18 (gmac1)",	/* 18 */
-	"int 19 (gmac2)",	/* 19 */
-	"int 20 (gmac3)",	/* 20 */
-	"int 21 (irq21)",	/* 21 */
-	"int 22 (irq22)",	/* 22 */
-	"int 23 (irq23)",	/* 23 */
-	"int 24 (irq24)",	/* 24 */
-	"int 25 (bridge_err)",	/* 25 */
-	"int 26 (pcie_link0)",	/* 26 */
-	"int 27 (pcie_link1)",	/* 27 */
-	"int 28 (pcie_link2)",	/* 28 */
-	"int 29 (pcie_link3)",	/* 29 */
-	"int 30 (gpio_b)",	/* 30 */
-	"int 31 (usb)",		/* 31 */
+	"pic int 0 (watchdog)",		/*  0 */
+	"pic int 1 (timer0)",		/*  1 */
+	"pic int 2 (timer1)",		/*  2 */
+	"pic int 3 (timer2)",		/*  3 */
+	"pic int 4 (timer3)",		/*  4 */
+	"pic int 5 (timer4)",		/*  5 */
+	"pic int 6 (timer5)",		/*  6 */
+	"pic int 7 (timer6)",		/*  7 */
+	"pic int 8 (timer7)",		/*  8 */
+	"pic int 9 (uart0)",		/*  9 */
+	"pic int 10 (uart1)",		/* 10 */
+	"pic int 11 (i2c0)",		/* 11 */
+	"pic int 12 (i2c1)",		/* 12 */
+	"pic int 13 (pcmcia)",		/* 13 */
+	"pic int 14 (gpio_a)",		/* 14 */
+	"pic int 15 (irq15)",		/* 15 */
+	"pic int 16 (bridge_tb)",	/* 16 */
+	"pic int 17 (gmac0)",		/* 17 */
+	"pic int 18 (gmac1)",		/* 18 */
+	"pic int 19 (gmac2)",		/* 19 */
+	"pic int 20 (gmac3)",		/* 20 */
+	"pic int 21 (irq21)",		/* 21 */
+	"pic int 22 (irq22)",		/* 22 */
+	"pic int 23 (irq23)",		/* 23 */
+	"pic int 24 (irq24)",		/* 24 */
+	"pic int 25 (bridge_err)",	/* 25 */
+	"pic int 26 (pcie_link0)",	/* 26 */
+	"pic int 27 (pcie_link1)",	/* 27 */
+	"pic int 28 (pcie_link2)",	/* 28 */
+	"pic int 29 (pcie_link3)",	/* 29 */
+	"pic int 30 (gpio_b)",		/* 30 */
+	"pic int 31 (usb)",		/* 31 */
 };
 
@@ -282,68 +285,68 @@
  */
 static const char * const rmixl_vecnames_common[NINTRVECS] = {
-	"int 0",	/*  0 */
-	"int 1",	/*  1 */
-	"int 2",	/*  2 */
-	"int 3",	/*  3 */
-	"int 4",	/*  4 */
-	"int 5",	/*  5 */
-	"int 6",	/*  6 */
-	"int 7",	/*  7 */
-	"int 8",	/*  8 */
-	"int 9",	/*  9 */
-	"int 10",	/* 10 */
-	"int 11",	/* 11 */
-	"int 12",	/* 12 */
-	"int 13",	/* 13 */
-	"int 14",	/* 14 */
-	"int 15",	/* 15 */
-	"int 16",	/* 16 */
-	"int 17",	/* 17 */
-	"int 18",	/* 18 */
-	"int 19",	/* 19 */
-	"int 20",	/* 20 */
-	"int 21",	/* 21 */
-	"int 22",	/* 22 */
-	"int 23",	/* 23 */
-	"int 24",	/* 24 */
-	"int 25",	/* 25 */
-	"int 26",	/* 26 */
-	"int 27",	/* 27 */
-	"int 28",	/* 28 */
-	"int 29",	/* 29 */
-	"int 30",	/* 30 */
-	"int 31",	/* 31 */
-	"int 32 (ipi)",	/* 32 */
-	"int 33 (fmn)",	/* 33 */
-	"int 34",	/* 34 */
-	"int 35",	/* 35 */
-	"int 36",	/* 36 */
-	"int 37",	/* 37 */
-	"int 38",	/* 38 */
-	"int 39",	/* 39 */
-	"int 40",	/* 40 */
-	"int 41",	/* 41 */
-	"int 42",	/* 42 */
-	"int 43",	/* 43 */
-	"int 44",	/* 44 */
-	"int 45",	/* 45 */
-	"int 46",	/* 46 */
-	"int 47",	/* 47 */
-	"int 48",	/* 48 */
-	"int 49",	/* 49 */
-	"int 50",	/* 50 */
-	"int 51",	/* 51 */
-	"int 52",	/* 52 */
-	"int 53",	/* 53 */
-	"int 54",	/* 54 */
-	"int 55",	/* 55 */
-	"int 56",	/* 56 */
-	"int 57",	/* 57 */
-	"int 58",	/* 58 */
-	"int 59",	/* 59 */
-	"int 60",	/* 60 */
-	"int 61",	/* 61 */
-	"int 62",	/* 63 */
-	"int 63",	/* 63 */
+	"vec 0",		/*  0 */
+	"vec 1",		/*  1 */
+	"vec 2",		/*  2 */
+	"vec 3",		/*  3 */
+	"vec 4",		/*  4 */
+	"vec 5",		/*  5 */
+	"vec 6",		/*  6 */
+	"vec 7",		/*  7 */
+	"vec 8 (ipi 0)",	/*  8 */
+	"vec 9 (ipi 1)",	/*  9 */
+	"vec 10 (ipi 2)",	/* 10 */
+	"vec 11 (ipi 3)",	/* 11 */
+	"vec 12 (ipi 4)",	/* 12 */
+	"vec 13 (ipi 5)",	/* 13 */
+	"vec 14 (ipi 6)",	/* 14 */
+	"vec 15 (fmn)",		/* 15 */
+	"vec 16",		/* 16 */
+	"vec 17",		/* 17 */
+	"vec 18",		/* 18 */
+	"vec 19",		/* 19 */
+	"vec 20",		/* 20 */
+	"vec 21",		/* 21 */
+	"vec 22",		/* 22 */
+	"vec 23",		/* 23 */
+	"vec 24",		/* 24 */
+	"vec 25",		/* 25 */
+	"vec 26",		/* 26 */
+	"vec 27",		/* 27 */
+	"vec 28",		/* 28 */
+	"vec 29",		/* 29 */
+	"vec 30",		/* 30 */
+	"vec 31",		/* 31 */
+	"vec 32",		/* 32 */
+	"vec 33",		/* 33 */
+	"vec 34",		/* 34 */
+	"vec 35",		/* 35 */
+	"vec 36",		/* 36 */
+	"vec 37",		/* 37 */
+	"vec 38",		/* 38 */
+	"vec 39",		/* 39 */
+	"vec 40",		/* 40 */
+	"vec 41",		/* 41 */
+	"vec 42",		/* 42 */
+	"vec 43",		/* 43 */
+	"vec 44",		/* 44 */
+	"vec 45",		/* 45 */
+	"vec 46",		/* 46 */
+	"vec 47",		/* 47 */
+	"vec 48",		/* 48 */
+	"vec 49",		/* 49 */
+	"vec 50",		/* 50 */
+	"vec 51",		/* 51 */
+	"vec 52",		/* 52 */
+	"vec 53",		/* 53 */
+	"vec 54",		/* 54 */
+	"vec 55",		/* 55 */
+	"vec 56",		/* 56 */
+	"vec 57",		/* 57 */
+	"vec 58",		/* 58 */
+	"vec 59",		/* 59 */
+	"vec 60",		/* 60 */
+	"vec 61",		/* 61 */
+	"vec 62",		/* 63 */
+	"vec 63",		/* 63 */
 };
 
@@ -354,4 +357,6 @@
 static uint32_t cpu_present_mask;
 
+kmutex_t *rmixl_ipi_lock;  /* covers RMIXL_PIC_IPIBASE */
+kmutex_t *rmixl_intr_lock; /* covers rest of PIC, and rmixl_intrhand[] */
 rmixl_intrhand_t rmixl_intrhand[NINTRVECS];
 
@@ -366,5 +371,5 @@
 static void rmixl_irt_init(int);
 static void rmixl_irt_disestablish(int);
-static void rmixl_irt_establish(int, int,
+static void rmixl_irt_establish(int, int, int,
 		rmixl_intr_trigger_t, rmixl_intr_polarity_t);
 
@@ -374,8 +379,9 @@
 #endif
 
-#if defined(IOINTR_DEBUG) || defined(DIAGNOSTIC)
-int rmixl_intrhand_print_subr(int);
-int rmixl_intrhand_print(void);
-int rmixl_irt_print(void);
+#if defined(DIAGNOSTIC) || defined(IOINTR_DEBUG) || defined(DDB)
+int  rmixl_intrhand_print_subr(int);
+int  rmixl_intrhand_print(void);
+int  rmixl_irt_print(void);
+void rmixl_ipl_eimr_map_print(void);
 #endif
 
@@ -392,18 +398,4 @@
 }
 
-static inline void
-rmixl_irt_entry_print(u_int irq)
-{
-#if defined(IOINTR_DEBUG) || defined(DDB)
-	uint32_t c0, c1;
-
-	if ((irq < 0) || (irq > NIRTS))
-		return;
-	c0 = RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC0(irq));
-	c1 = RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC1(irq));
-	printf("irt[%d]: %#x, %#x\n", irq, c0, c1);
-#endif
-}
-
 void
 evbmips_intr_init(void)
@@ -414,18 +406,4 @@
 	     || cpu_rmixls(mips_options.mips_cpu));
 
-#ifdef IOINTR_DEBUG
-	printf("IPL_NONE=%d, mask %#"PRIx64"\n",
-		IPL_NONE, ipl_eimr_map[IPL_NONE]);
-	printf("IPL_SOFTCLOCK=%d, mask %#"PRIx64"\n",
-		IPL_SOFTCLOCK, ipl_eimr_map[IPL_SOFTCLOCK]);
-	printf("IPL_SOFTNET=%d, mask %#"PRIx64"\n",
-		IPL_SOFTNET, ipl_eimr_map[IPL_SOFTNET]);
-	printf("IPL_VM=%d, mask %#"PRIx64"\n",
-		IPL_VM, ipl_eimr_map[IPL_VM]);
-	printf("IPL_SCHED=%d, mask %#"PRIx64"\n",
-		IPL_SCHED, ipl_eimr_map[IPL_HIGH]);
-	printf("IPL_HIGH=%d, mask %#"PRIx64"\n",
-		IPL_HIGH, ipl_eimr_map[IPL_NONE]);
-#endif
 
 #ifdef DIAGNOSTIC
@@ -435,9 +413,15 @@
 #endif
 
+	rmixl_ipi_lock  = mutex_obj_alloc(MUTEX_DEFAULT, IPL_HIGH);
+	rmixl_intr_lock = mutex_obj_alloc(MUTEX_DEFAULT, IPL_HIGH);
+
+	mutex_enter(rmixl_intr_lock);
+
 	/*
 	 * initialize (zero) all IRT Entries in the PIC
 	 */
-	for (int i=0; i < NIRTS; i++)
+	for (u_int i = 0; i < NIRTS; i++) {
 		rmixl_irt_init(i);
+	}
 
 	/*
@@ -455,4 +439,5 @@
 	rmixl_pic_init_done = 1;
 #endif
+	mutex_exit(rmixl_intr_lock);
 
 }
@@ -464,13 +449,16 @@
  * note the 'mpsafe' arg here is a placeholder only
  */
-void *
+void
 rmixl_intr_init_clk(void)
 {
-	int vec = ffs(MIPS_INT_MASK_5 >> 8) - 1;
+	const int vec = ffs(MIPS_INT_MASK_5 >> MIPS_INT_MASK_SHIFT) - 1;
+
+	mutex_enter(rmixl_intr_lock);
+
 	void *ih = rmixl_vec_establish(vec, 0, IPL_SCHED, NULL, NULL, false);
 	if (ih == NULL)
 		panic("%s: establish vec %d failed", __func__, vec);
-	
-	return ih;
+
+	mutex_exit(rmixl_intr_lock);
 }
 
@@ -479,16 +467,21 @@
  * establish IPI interrupt and send function
  */
-void *
+void
 rmixl_intr_init_ipi(void)
 {
-	void *ih = rmixl_vec_establish(RMIXL_INTRVEC_IPI, -1, IPL_SCHED,
-		rmixl_ipi_intr, NULL, false);
-	if (ih == NULL)
-		panic("%s: establish vec %d failed",
-			__func__, RMIXL_INTRVEC_IPI);
+	mutex_enter(rmixl_intr_lock);
+
+	for (u_int ipi = 0; ipi < NIPIS; ipi++) {
+		const u_int vec = RMIXL_INTRVEC_IPI + ipi;
+		void * const ih = rmixl_vec_establish(vec, -1, IPL_SCHED,
+			rmixl_ipi_intr, (void *)(uintptr_t)ipi, true);
+		if (ih == NULL)
+			panic("%s: establish ipi %d at vec %d failed",
+				__func__, ipi, vec);
+	}
 
 	mips_locoresw.lsw_send_ipi = rmixl_send_ipi;
 
-	return ih;
+	mutex_exit(rmixl_intr_lock);
 }
 #endif 	/* MULTIPROCESSOR */
@@ -502,9 +495,6 @@
 {
 	struct rmixl_cpu_softc *sc = (void *)ci->ci_softc;
+
 	KASSERT(sc != NULL);
-
-	/* zero the EIRR ? */
-	uint64_t eirr = 0;
-	asm volatile("dmtc0 %0, $9, 6;" :: "r"(eirr));
 
 	for (int vec=0; vec < NINTRVECS; vec++)
@@ -514,6 +504,6 @@
 			rmixl_intr_string(vec));
 
-	KASSERT(ci->ci_cpuid < (sizeof(cpu_present_mask) * 8));
-	cpu_present_mask |= 1 << ci->ci_cpuid;
+	KASSERT(cpu_index(ci) < (sizeof(cpu_present_mask) * 8));
+	atomic_or_32((volatile uint32_t *)&cpu_present_mask, 1 << cpu_index(ci));
 }
 
@@ -522,18 +512,21 @@
  */
 const char *
-rmixl_intr_string(int irq)
-{
-	if (irq < 0 || irq >= NINTRVECS)
-		panic("%s: irq index %d out of range, max %d",
-			__func__, irq, NIRTS - 1);
-
-	if (irq >= NIRTS)
-		return rmixl_vecnames_common[irq];
-
+rmixl_intr_string(int vec)
+{
+	int irt;
+
+	if (vec < 0 || vec >= NINTRVECS)
+		panic("%s: vec index %d out of range, max %d",
+			__func__, vec, NINTRVECS - 1);
+
+	if (! RMIXL_VECTOR_IS_IRT(vec))
+		return rmixl_vecnames_common[vec];
+
+	irt = RMIXL_VECTOR_IRT(vec);
 	switch(cpu_rmixl_chip_type(mips_options.mips_cpu)) {
 	case CIDFL_RMI_TYPE_XLR:
-		return rmixl_intr_string_xlr(irq);
+		return rmixl_intr_string_xlr(irt);
 	case CIDFL_RMI_TYPE_XLS:
-		return rmixl_intr_string_xls(irq);
+		return rmixl_intr_string_xls(irt);
 	case CIDFL_RMI_TYPE_XLP:
 		panic("%s: RMI XLP not yet supported", __func__);
@@ -544,11 +537,11 @@
 
 static const char *
-rmixl_intr_string_xlr(int irq)
-{
-	return rmixl_irtnames_xlrxxx[irq];
+rmixl_intr_string_xlr(int irt)
+{
+	return rmixl_irtnames_xlrxxx[irt];
 }
 
 static const char *
-rmixl_intr_string_xls(int irq)
+rmixl_intr_string_xls(int irt)
 {
 	const char *name;
@@ -559,9 +552,9 @@
 	case MIPS_XLS404LITE:
 	case MIPS_XLS408LITE:
-		name = rmixl_irtnames_xls1xx[irq];
+		name = rmixl_irtnames_xls1xx[irt];
 		break;
 	case MIPS_XLS204:
 	case MIPS_XLS208:
-		name = rmixl_irtnames_xls2xx[irq];
+		name = rmixl_irtnames_xls2xx[irt];
 		break;
 	case MIPS_XLS404:
@@ -570,8 +563,8 @@
 	case MIPS_XLS608:
 	case MIPS_XLS616:
-		name = rmixl_irtnames_xls4xx[irq];
+		name = rmixl_irtnames_xls4xx[irt];
 		break;
 	default:
-		name = rmixl_vecnames_common[irq];
+		name = rmixl_vecnames_common[RMIXL_IRT_VECTOR(irt)];
 		break;
 	}
@@ -633,36 +626,45 @@
 /*
  * rmixl_irt_init
- * - invalidate IRT Entry for irq
+ * - initialize IRT Entry for given index
  * - unmask Thread#0 in low word (assume we only have 1 thread)
  */
 static void
-rmixl_irt_init(int irq)
-{
-	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC1(irq), 0);	/* high word */
-	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC0(irq), 0);	/* low  word */
+rmixl_irt_init(int irt)
+{
+	KASSERT(irt < NIRTS);
+	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC1(irt), 0);	/* high word */
+	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC0(irt), 0);	/* low  word */
 }
 
 /*
  * rmixl_irt_disestablish
- * - invalidate IRT Entry for irq
- * - writes to IRTENTRYC1 only; leave IRTENTRYC0 as-is
+ * - invalidate IRT Entry for given index
  */
 static void
-rmixl_irt_disestablish(int irq)
-{
-	DPRINTF(("%s: irq %d, irtc1 %#x\n", __func__, irq, 0));
-	rmixl_irt_init(irq);
+rmixl_irt_disestablish(int irt)
+{
+	KASSERT(mutex_owned(rmixl_intr_lock));
+	DPRINTF(("%s: irt %d, irtc1 %#x\n", __func__, irt, 0));
+	rmixl_irt_init(irt);
 }
 
 /*
  * rmixl_irt_establish
- * - construct an IRT Entry for irq and write to PIC
+ * - construct an IRT Entry for irt and write to PIC
  */
 static void
-rmixl_irt_establish(int irq, int cpumask, rmixl_intr_trigger_t trigger,
+rmixl_irt_establish(int irt, int vec, int cpumask, rmixl_intr_trigger_t trigger,
 	rmixl_intr_polarity_t polarity)
 {
 	uint32_t irtc1;
 	uint32_t irtc0;
+
+	KASSERT(mutex_owned(rmixl_intr_lock));
+
+	if (irt >= NIRTS)
+		panic("%s: bad irt %d\n", __func__, irt);
+
+	if (! RMIXL_VECTOR_IS_IRT(vec))
+		panic("%s: bad vec %d\n", __func__, vec);
 
 	switch (trigger) {
@@ -687,6 +689,6 @@
 	 * XXX IRT entries are not shared
 	 */
-	KASSERT(RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC0(irq)) == 0);
-	KASSERT(RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC1(irq)) == 0);
+	KASSERT(RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC0(irt)) == 0);
+	KASSERT(RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC1(irt)) == 0);
 
 	irtc0 = rmixl_irt_thread_mask(cpumask);
@@ -694,20 +696,24 @@
 	irtc1  = RMIXL_PIC_IRTENTRYC1_VALID;
 	irtc1 |= RMIXL_PIC_IRTENTRYC1_GL;	/* local */
+	KASSERT((irtc1 & RMIXL_PIC_IRTENTRYC1_NMI) == 0);
 
 	if (trigger == RMIXL_TRIG_LEVEL)
 		irtc1 |= RMIXL_PIC_IRTENTRYC1_TRG;
+	KASSERT((irtc1 & RMIXL_PIC_IRTENTRYC1_NMI) == 0);
 
 	if ((polarity == RMIXL_POLR_FALLING) || (polarity == RMIXL_POLR_LOW))
 		irtc1 |= RMIXL_PIC_IRTENTRYC1_P;
-
-	irtc1 |= irq;	/* route to vector 'irq' */
+	KASSERT((irtc1 & RMIXL_PIC_IRTENTRYC1_NMI) == 0);
+
+	irtc1 |= vec;			/* vector in EIRR */
+	KASSERT((irtc1 & RMIXL_PIC_IRTENTRYC1_NMI) == 0);
 
 	/*
 	 * write IRT Entry to PIC
 	 */
-	DPRINTF(("%s: irq %d, irtc0 %#x, irtc1 %#x\n",
-		__func__, irq, irtc0, irtc1));
-	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC0(irq), irtc0);	/* low  word */
-	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC1(irq), irtc1);	/* high word */
+	DPRINTF(("%s: vec %d (%#x), irt %d, irtc0 %#x, irtc1 %#x\n",
+		__func__, vec, vec, irt, irtc0, irtc1));
+	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC0(irt), irtc0);	/* low  word */
+	RMIXL_PICREG_WRITE(RMIXL_PIC_IRTENTRYC1(irt), irtc1);	/* high word */
 }
 
@@ -717,9 +723,11 @@
 {
 	rmixl_intrhand_t *ih;
+	uint64_t eimr_bit;
 	int s;
 
-	DPRINTF(("%s: vec %d, cpumask %#x, ipl %d, func %p, arg %p, "
-		"vec %d\n",
-			__func__, vec, cpumask, ipl, func, arg, vec));
+	KASSERT(mutex_owned(rmixl_intr_lock));
+
+	DPRINTF(("%s: vec %d cpumask %#x ipl %d func %p arg %p mpsafe %d\n",
+			__func__, vec, cpumask, ipl, func, arg, mpsafe));
 #ifdef DIAGNOSTIC
 	if (rmixl_pic_init_done == 0)
@@ -740,12 +748,26 @@
 
 	ih = &rmixl_intrhand[vec];
-
-	ih->ih_func = func;
+	if (ih->ih_func != NULL) {
+#ifdef DIAGNOSTIC
+		printf("%s: intrhand[%d] busy\n", __func__, vec);
+#endif
+		splx(s);
+		return NULL;
+	}
+
 	ih->ih_arg = arg;
 	ih->ih_mpsafe = mpsafe;
-	ih->ih_irq = vec;
+	ih->ih_vec = vec;
 	ih->ih_ipl = ipl;
 	ih->ih_cpumask = cpumask;
 
+	eimr_bit = (uint64_t)1 << vec;
+	for (int i=ih->ih_ipl; --i >= 0; ) {
+		KASSERT((ipl_eimr_map[i] & eimr_bit) == 0);
+		ipl_eimr_map[i] |= eimr_bit;
+	}
+
+	ih->ih_func = func;	/* do this last */
+
 	splx(s);
 
@@ -753,11 +775,15 @@
 }
 
+/*
+ * rmixl_intr_establish
+ * - used to establish an IRT-based interrupt only
+ */
 void *
-rmixl_intr_establish(int irq, int cpumask, int ipl,
+rmixl_intr_establish(int irt, int cpumask, int ipl,
 	rmixl_intr_trigger_t trigger, rmixl_intr_polarity_t polarity,
 	int (*func)(void *), void *arg, bool mpsafe)
 {
 	rmixl_intrhand_t *ih;
-	int s;
+	int vec;
 
 #ifdef DIAGNOSTIC
@@ -769,27 +795,28 @@
 	 * check args
 	 */
-	if (irq < 0 || irq >= NINTRVECS)
-		panic("%s: irq %d out of range, max %d",
-			__func__, irq, NIRTS - 1);
+	if (irt < 0 || irt >= NIRTS)
+		panic("%s: irt %d out of range, max %d",
+			__func__, irt, NIRTS - 1);
 	if (ipl <= 0 || ipl >= _IPL_N)
 		panic("%s: ipl %d out of range, min %d, max %d",
 			__func__, ipl, 1, _IPL_N - 1);
 
-	DPRINTF(("%s: irq %d, ipl %d\n", __func__, irq, ipl));
-
-	s = splhigh();
+	vec = RMIXL_IRT_VECTOR(irt);
+
+	DPRINTF(("%s: irt %d, vec %d, ipl %d\n", __func__, irt, vec, ipl));
+
+	mutex_enter(rmixl_intr_lock);
 
 	/*
 	 * establish vector
 	 */
-	ih = rmixl_vec_establish(irq, cpumask, ipl, func, arg, mpsafe);
+	ih = rmixl_vec_establish(vec, cpumask, ipl, func, arg, mpsafe);
 
 	/*
 	 * establish IRT Entry
 	 */
-	if (irq < 32)
-		rmixl_irt_establish(irq, cpumask, trigger, polarity);
-
-	splx(s);
+	rmixl_irt_establish(irt, vec, cpumask, trigger, polarity);
+
+	mutex_exit(rmixl_intr_lock);
 
 	return ih;
@@ -800,13 +827,17 @@
 {
 	rmixl_intrhand_t *ih = cookie;
-	int s;
-
-	KASSERT(ih = &rmixl_intrhand[ih->ih_irq]);
-
-	s = splhigh();
-
-	ih->ih_func = NULL;	/* XXX race */
-
-	splx(s);
+	uint64_t eimr_bit;
+
+	KASSERT(mutex_owned(rmixl_intr_lock));
+	KASSERT(ih->ih_vec < NINTRVECS);
+	KASSERT(ih == &rmixl_intrhand[ih->ih_vec]);
+
+	ih->ih_func = NULL;	/* do this first */
+
+	eimr_bit = (uint64_t)1 << ih->ih_vec;
+	for (int i=ih->ih_ipl; --i >= 0; ) {
+		KASSERT((ipl_eimr_map[i] & eimr_bit) != 0);
+		ipl_eimr_map[i] ^= eimr_bit;
+	}
 }
 
@@ -815,17 +846,15 @@
 {
 	rmixl_intrhand_t *ih = cookie;
-	int vec;
-	int s;
-
-	vec = ih->ih_irq;
-
-	KASSERT(ih = &rmixl_intrhand[vec]);
-
-	s = splhigh();
+	const int vec = ih->ih_vec;
+
+	KASSERT(vec < NINTRVECS);
+	KASSERT(ih == &rmixl_intrhand[vec]);
+
+	mutex_enter(rmixl_intr_lock);
 
 	/*
 	 * disable/invalidate the IRT Entry if needed
 	 */
-	if (vec < 32)
+	if (RMIXL_VECTOR_IS_IRT(vec))
 		rmixl_irt_disestablish(vec);
 
@@ -835,5 +864,5 @@
 	rmixl_vec_disestablish(cookie);
 
-	splx(s);
+	mutex_exit(rmixl_intr_lock);
 }
 
@@ -843,5 +872,5 @@
 	struct rmixl_cpu_softc *sc = (void *)curcpu()->ci_softc;
 
-	DPRINTF(("%s: cpu%ld: ipl %d, pc %#"PRIxVADDR", pending %#x\n",
+	DPRINTF(("%s: cpu%u: ipl %d, pc %#"PRIxVADDR", pending %#x\n",
 		__func__, cpu_number(), ipl, pc, pending));
 
@@ -860,13 +889,20 @@
 
 		asm volatile("dmfc0 %0, $9, 6;" : "=r"(eirr));
+		asm volatile("dmfc0 %0, $9, 7;" : "=r"(eimr));
 
 #ifdef IOINTR_DEBUG
-		asm volatile("dmfc0 %0, $9, 7;" : "=r"(eimr));
-		printf("%s: eirr %#"PRIx64", eimr %#"PRIx64", mask %#"PRIx64"\n",
-			__func__, eirr, eimr, ipl_eimr_map[ipl-1]);
+		printf("%s: cpu%u: eirr %#"PRIx64", eimr %#"PRIx64", mask %#"PRIx64"\n",
+			__func__, cpu_number(), eirr, eimr, ipl_eimr_map[ipl-1]);
 #endif	/* IOINTR_DEBUG */
 
+		/*
+		 * reduce eirr to
+		 * - ints that are enabled at or below this ipl
+		 * - exclude count/compare clock and soft ints
+		 *   they are handled elsewhere
+		 */
 		eirr &= ipl_eimr_map[ipl-1];
-		eirr &= ~(MIPS_SOFT_INT_MASK >> 8);	/* mask off soft ints */
+		eirr &= ~ipl_eimr_map[ipl];
+		eirr &= ~((MIPS_INT_MASK_5 | MIPS_SOFT_INT_MASK) >> 8);
 		if (eirr == 0)
 			break;
@@ -874,19 +910,17 @@
 		vec = 63 - dclz(eirr);
 		ih = &rmixl_intrhand[vec];
-
-		asm volatile("dmfc0 %0, $9, 7;" : "=r"(eimr));
-		asm volatile("dmtc0 $0, $9, 7;");
 		vecbit = 1ULL << vec;
+		KASSERT (ih->ih_ipl == ipl);
 		KASSERT ((vecbit & eimr) == 0);
 		KASSERT ((vecbit & RMIXL_EIRR_PRESERVE_MASK) == 0);
-		asm volatile("dmfc0 %0, $9, 6;" : "=r"(eirr));
-		eirr &= RMIXL_EIRR_PRESERVE_MASK;
-		eirr |= vecbit;
-		asm volatile("dmtc0 %0, $9, 6;" :: "r"(eirr));
-		asm volatile("dmtc0 %0, $9, 7;" :: "r"(eimr));
-
-		if (vec < 32)
+
+		/*
+		 * ack in EIRR, and in PIC if needed,
+		 * the irq we are about to handle
+		 */
+		rmixl_eirr_ack(eimr, vecbit, RMIXL_EIRR_PRESERVE_MASK);
+		if (RMIXL_VECTOR_IS_IRT(vec))
 			RMIXL_PICREG_WRITE(RMIXL_PIC_INTRACK,
-				(uint32_t)vecbit);
+				1 << RMIXL_VECTOR_IRT(vec));
 
 		if (ih->ih_func != NULL) {
@@ -895,4 +929,8 @@
 				(void)(*ih->ih_func)(ih->ih_arg);
 			} else {
+				KASSERTMSG(ipl == IPL_VM,
+				    ("%s: %s: ipl (%d) != IPL_VM for KERNEL_LOCK",
+				    __func__, sc->sc_vec_evcnts[vec].ev_name,
+				    ipl));
 				KERNEL_LOCK(1, NULL);
 				(void)(*ih->ih_func)(ih->ih_arg);
@@ -903,5 +941,9 @@
 #endif /* MULTIPROCESSOR */
 		}
-
+		KASSERT(ipl == ih->ih_ipl);
+		KASSERTMSG(curcpu()->ci_cpl >= ipl,
+		    ("%s: after %s: cpl (%d) < ipl %d",
+		    __func__, sc->sc_vec_evcnts[vec].ev_name,
+		    ipl, curcpu()->ci_cpl));
 		sc->sc_vec_evcnts[vec].ev_count++;
 	}
@@ -912,23 +954,23 @@
 rmixl_send_ipi(struct cpu_info *ci, int tag)
 {
-	const cpuid_t cpu = ci->ci_cpuid;
-	uint32_t core = (uint32_t)(cpu >> 2);
-	uint32_t thread = (uint32_t)(cpu & __BITS(1,0));
+	const cpuid_t cpuid = ci->ci_cpuid;
+	uint32_t core = (uint32_t)(cpuid >> 2);
+	uint32_t thread = (uint32_t)(cpuid & __BITS(1,0));
 	uint64_t req = 1 << tag;
 	uint32_t r;
-	extern volatile u_long cpus_running;
-
-	if ((cpus_running & 1 << ci->ci_cpuid) == 0)
+
+	if (! CPUSET_HAS_P(cpus_running, cpu_index(ci)))
 		return -1;
 
-	KASSERT(tag < NIPIS);
+	KASSERT((tag >= 0) && (tag < NIPIS));
 
 	r = (thread << RMIXL_PIC_IPIBASE_ID_THREAD_SHIFT)
 	  | (core << RMIXL_PIC_IPIBASE_ID_CORE_SHIFT)
-	  | RMIXL_INTRVEC_IPI;
-
+	  | (RMIXL_INTRVEC_IPI + tag);
+
+	mutex_enter(rmixl_ipi_lock);
 	atomic_or_64(&ci->ci_request_ipis, req);
-
 	RMIXL_PICREG_WRITE(RMIXL_PIC_IPIBASE, r);
+	mutex_exit(rmixl_ipi_lock);
 
 	return 0;
@@ -939,23 +981,31 @@
 {
 	struct cpu_info * const ci = curcpu();
-	uint64_t ipi_mask;
-
-	ipi_mask = atomic_swap_64(&ci->ci_request_ipis, 0);
-	if (ipi_mask == 0)
+	const uint64_t ipi_mask = 1 << (uintptr_t)arg;
+
+	KASSERT(ci->ci_cpl >= IPL_SCHED);
+	KASSERT((uintptr_t)arg < NIPIS);
+
+	/* if the request is clear, it was previously processed */
+	if ((ci->ci_request_ipis & ipi_mask) == 0)
 		return 0;
 
+	atomic_or_64(&ci->ci_active_ipis, ipi_mask);
+	atomic_and_64(&ci->ci_request_ipis, ~ipi_mask);
+
 	ipi_process(ci, ipi_mask);
 
+	atomic_and_64(&ci->ci_active_ipis, ~ipi_mask);
+
 	return 1;
 }
 #endif	/* MULTIPROCESSOR */
 
-#if defined(DIAGNOSTIC) || defined(IOINTR_DEBUG)
+#if defined(DIAGNOSTIC) || defined(IOINTR_DEBUG) || defined(DDB)
 int
 rmixl_intrhand_print_subr(int vec)
 {
 	rmixl_intrhand_t *ih = &rmixl_intrhand[vec];
-	printf("vec %d: func %p, arg %p, irq %d, ipl %d, mask %#x\n",
-		vec, ih->ih_func, ih->ih_arg, ih->ih_irq, ih->ih_ipl,
+	printf("vec %d: func %p, arg %p, vec %d, ipl %d, mask %#x\n",
+		vec, ih->ih_func, ih->ih_arg, ih->ih_vec, ih->ih_ipl,
 		ih->ih_cpumask);
 	return 0;
@@ -968,4 +1018,17 @@
 	return 0;
 }
+
+static inline void
+rmixl_irt_entry_print(u_int irt)
+{
+	uint32_t c0, c1;
+
+	if ((irt < 0) || (irt > NIRTS))
+		return;
+	c0 = RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC0(irt));
+	c1 = RMIXL_PICREG_READ(RMIXL_PIC_IRTENTRYC1(irt));
+	printf("irt[%d]: %#x, %#x\n", irt, c0, c1);
+}
+
 int
 rmixl_irt_print(void)
@@ -976,3 +1039,23 @@
 	return 0;
 }
+
+void
+rmixl_ipl_eimr_map_print(void)
+{
+	printf("IPL_NONE=%d, mask %#"PRIx64"\n",
+		IPL_NONE, ipl_eimr_map[IPL_NONE]);
+	printf("IPL_SOFTCLOCK=%d, mask %#"PRIx64"\n",
+		IPL_SOFTCLOCK, ipl_eimr_map[IPL_SOFTCLOCK]);
+	printf("IPL_SOFTNET=%d, mask %#"PRIx64"\n",
+		IPL_SOFTNET, ipl_eimr_map[IPL_SOFTNET]);
+	printf("IPL_VM=%d, mask %#"PRIx64"\n",
+		IPL_VM, ipl_eimr_map[IPL_VM]);
+	printf("IPL_SCHED=%d, mask %#"PRIx64"\n",
+		IPL_SCHED, ipl_eimr_map[IPL_SCHED]);
+	printf("IPL_DDB=%d, mask %#"PRIx64"\n",
+		IPL_DDB, ipl_eimr_map[IPL_DDB]);
+	printf("IPL_HIGH=%d, mask %#"PRIx64"\n",
+		IPL_HIGH, ipl_eimr_map[IPL_HIGH]);
+}
+
 #endif
